import type { Writable } from 'type-fest';
import { type AllowedComponentProps, type ComponentInternalInstance, type ComponentPublicInstance, type ComputedOptions, type MethodOptions, type Raw, type VNode, type VNodeProps } from 'vue';
interface ModalInjection<C extends ModalComponent> {
    id: string;
    component: ModalComponentUnwrapped<C>;
    props: ModalComponentProps<C>;
    vnode: VNode;
}
export declare const ModalContainer: import("vue").DefineComponent<{}, () => VNode<import("vue").RendererNode, import("vue").RendererElement, {
    [key: string]: any;
}>, {}, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {}, string, VNodeProps & AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{}>>, {}, {}>;
export type Vue__ComponentPublicInstanceConstructor<T extends ComponentPublicInstance<Props, RawBindings, D, C, M> = ComponentPublicInstance<any>, Props = any, RawBindings = any, D = any, C extends ComputedOptions = ComputedOptions, M extends MethodOptions = MethodOptions> = {
    __isFragment?: never;
    __isTeleport?: never;
    __isSuspense?: never;
    new (...args: any[]): T;
};
export type ObjectComponentConfig<T extends Vue__ComponentPublicInstanceConstructor> = T extends Vue__ComponentPublicInstanceConstructor<infer P> ? P : never;
export type ObjectComponentProps<T extends Vue__ComponentPublicInstanceConstructor> = Writable<Omit<ObjectComponentConfig<T>['$props'], keyof VNodeProps | keyof AllowedComponentProps>>;
type ObjectOrDefault<T> = T extends object ? T : PropsWithCallback<{}>;
export type ModalComponent = Vue__ComponentPublicInstanceConstructor | ((props: any) => any);
export type ModalComponentConfig<T> = T extends Vue__ComponentPublicInstanceConstructor ? {
    props: ObjectComponentProps<T>;
    component: Raw<T>;
} : T extends (props: infer P) => any ? {
    props: Omit<ObjectOrDefault<P>, keyof VNodeProps | keyof AllowedComponentProps>;
    component: T;
} : never;
export type ModalComponentUnwrapped<T extends ModalComponent> = ModalComponentConfig<T>['component'];
export type ModalComponentProps<T extends ModalComponent> = ModalComponentConfig<T>['props'];
interface PropsWithCallback<T> {
    callback?: (result: T) => void;
}
type ComponentReturn<M extends ModalComponent> = ModalComponentProps<M> extends PropsWithCallback<infer R> ? R : never;
export type AnyComponentPublicInstance = {
    $: ComponentInternalInstance;
};
export declare function createModalInjection<C extends ModalComponent>(component: C, props: ModalComponentProps<C>): ModalInjection<C>;
export declare function removeModalInjection(injection: ModalInjection<any>): void;
export declare function removeModalInjectionByInstance(instance: AnyComponentPublicInstance): void;
export declare function removeModalInjectionByInternalInstance(instance: ComponentInternalInstance): void;
export declare function removeModalInjectionByVnode(vnode: VNode): boolean;
export declare function presentModal<C extends ModalComponent, R extends ComponentReturn<C>>(component: C, props: Omit<ModalComponentProps<C>, 'callback'>): Promise<R | undefined>;
export {};
